/*
 * C
 *
 * Copyright 2013-2015 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef _LLCOMM_UART
#define _LLCOMM_UART

#include "LLCOMM_BUFFERED_CONNECTION.h"

#define LLCOMM_UART_TX_BUFFER_SIZE 50
#define LLCOMM_UART_RX_BUFFER_SIZE 50

// Define the mapping between platform ids and index in BSP COM table
typedef enum
{
	UART0_INDEX = 0,
	UART1_INDEX = 1,
} EVAL_COM_TypeDef;

typedef struct LLCOMM_UART
{
	struct LLCOMM_BUFFERED_CONNECTION header;
	int32_t platformId;
	EVAL_COM_TypeDef comIndex;
	uint8_t txItEnabled;
	uint8_t txBuffer[LLCOMM_UART_TX_BUFFER_SIZE];
	uint8_t rxBuffer[LLCOMM_UART_RX_BUFFER_SIZE];
} LLCOMM_UART;

void LLCOMM_UART_new(LLCOMM_UART* env);

void comm_impl_event(int32_t code);

#endif
