/*
 * C
 *
 * Copyright 2013-2015 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#include "LLCOMM_UART.h"
#include <stdint.h>
#include "LLCOMM_impl.h"
#include "microej.h"

static struct LLCOMM_UART conn0;
static struct LLCOMM_UART conn1;

LLCOMM_UART* createLLCOMM_UART(LLCOMM_UART* LLCOMM_UART, int32_t platformId, EVAL_COM_TypeDef comIndex)
{
	LLCOMM_UART_new(LLCOMM_UART);
	LLCOMM_UART->platformId = platformId;
	LLCOMM_UART->comIndex = comIndex;
	LLCOMM_UART->txItEnabled = MICROEJ_FALSE;
	return LLCOMM_UART;
}

void LLCOMM_IMPL_initialize(void)
{
	printf("LLCOMM_IMPL_initialize\n");
	uint8_t addResult = LLCOMM_addConnection((LLCOMM_CONNECTION*)createLLCOMM_UART(&conn0, 0, UART0_INDEX));
	if( addResult == 1 ) {
		printf("'conn0' connection added\n");
	} else {
		printf("Maximum number of connections is reached, 'conn0' connection has not been added\n");
	}
	addResult = LLCOMM_addConnection((LLCOMM_CONNECTION*)createLLCOMM_UART(&conn1, 1, UART1_INDEX));
	if( addResult == 1 ) {
		printf("'conn1' connection added\n");
	} else {
		printf("Maximum number of connections is reached, 'conn1' connection has not been added\n");
	}
}

void LLCOMM_IMPL_syncConnectionsEnter(void)
{
	// Does nothing by default. This implementation does not support dynamic connections.
}

void LLCOMM_IMPL_syncConnectionsExit(void)
{
	// Does nothing by default. This implementation does not support dynamic connections.
}
